



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>获得 LayoutInflater 实例的三种方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">获得 LayoutInflater 实例的三种方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 23:37:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在实际开发中LayoutInflater这个类还是非常有用的，它的作用类似于findViewById()。不同点是LayoutInflater是用来找res/layout/下的xml布局文件，并且实例化；而findViewById()是找xml布局文件下的具体widget控件(如Button、TextView等)。 具体作用：</p>
<p>1、对于一个没有被载入或者想要动态载入的界面，都需要使用LayoutInflater.inflate()来载入；</p>
<p>2、对于一个已经载入的界面，就可以使用Activiyt.findViewById()方法来获得其中的界面元素。</p>
<p>LayoutInflater 是一个抽象类，在文档中如下声明：</p>
<p>　　public&nbsp;abstract&nbsp;class&nbsp;LayoutInflater&nbsp;extends&nbsp;Object</p>
<p><strong>获得 LayoutInflater 实例的三种方式:</strong></p>
<p><strong>1.</strong>LayoutInflater inflater = getLayoutInflater();&nbsp; //调用Activity的getLayoutInflater()</p>
<p><strong>2.</strong>LayoutInflater localinflater =(LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);</p>
<p><strong>3.</strong>&nbsp;LayoutInflater inflater = LayoutInflater.from(context);</p>
<p>其实，这三种方式本质是相同的，从源码中可以看出：</p>
<p><strong>getLayoutInflater()：</strong></p>
<p>Activity 的 getLayoutInflater() 方法是调用 PhoneWindow 的getLayoutInflater()方法，看一下该源代码：</p>
<p>public&nbsp;PhoneWindow(Context context) {</p>
<p>　　&nbsp;super(context);</p>
<p>　　 mLayoutInflater = LayoutInflater.from(context);</p>
<p>}</p>
<p>可以看出它其实是调用 LayoutInflater.from(context)。</p>
<p><strong>LayoutInflater.from(context)：</strong></p>
<p><strong>public&nbsp;</strong><strong>static</strong>&nbsp;LayoutInflater from(Context context) {</p>
<p>　　 LayoutInflater LayoutInflater = &nbsp;(LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);</p>
<p><strong>　　&nbsp;if</strong>&nbsp;(LayoutInflater ==<strong>null</strong>) {</p>
<p>　　　　　　&nbsp;<strong>throw&nbsp;</strong><strong>new</strong>&nbsp;AssertionError("LayoutInflater not found.");</p>
<p>　　 }</p>
<p>　　&nbsp;<strong>return</strong>&nbsp;LayoutInflater;</p>
<p>}</p>
<p>可以看出它其实调用 context.getSystemService()。</p>
<p><strong>结论：所以这三种方式最终本质是都是调用的Context.getSystemService()。</strong></p>
<p><strong>inflate 方法</strong>&nbsp;通过 sdk 的 api 文档，可以知道该方法有以下几种过载形式，返回值均是 View 对象，如下：</p>
<div>
<pre class="prettyprint linenums">
     public View inflate (int resource, ViewGroup root);<br />
     public View inflate (XmlPullParser parser, ViewGroup root);<br />
     public View inflate (XmlPullParser parser, ViewGroup root, boolean attachToRoot);<br />
     public View inflate (int resource, ViewGroup root, boolean attachToRoot); 

     LayoutInflater inflater = (LayoutInflater)getSystemService(LAYOUT_INFLATER_SERVICE);<br />
     View view = inflater.inflate(R.layout.custom, (ViewGroup)findViewById(R.id.test));<br />
     //EditText editText = (EditText)findViewById(R.id.content);<br />
     // error <br />　　　　EditText editText = (EditText)view.findViewById(R.id.content);</pre>
</div>
<p><strong>对于上面代码，指定了第二个参数 ViewGroup root，当然你也可以设置为 null 值。</strong></p>
<p>注意：</p>
<p>&middot;inflate方法与 findViewById 方法不同；</p>
<p>&middot;inflater 是用来找 res/layout下的 xml 布局文件，并且实例化；</p>
<p>&middot;findViewById() 是找具体 xml 布局文件中的具体 widget 控件(如:Button、TextView 等)。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9p12k9x.html">javaScript的内置对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rymjd8.html">&lbrack;tmp&rsqb; hu60&commat;所有人插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql37geq.html">从零开始学习Node&period;js例子七  发送HTTP客户端请求并显示响应结果</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2rx0o9.html">Sqli-LABS通关笔录-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zm2jd9.html">SL4A</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnmjgrq.html">paper 9：SVM番外篇：支持向量机系列六：Duality &mdash;&mdash; 关于 dual 问题推导的一些补充理论。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydx07mq.html">2015美团网 哈工大 第k个排列</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xly4g9.html">用Android-X86和VirtualBox打造高性能Android开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xldp68.html">angularjs 更新局部作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvly6xq.html">bug经验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmy6xx9.html">c语言中的&num;ifndef、&num;def、&num;endif等宏是什么意思</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yp0nr8.html">MVC3&plus;EF4&period;1学习系列&lpar;九&rpar;-----EF4&period;1其他的一些技巧的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m4jxm8.html">如何快速把 Vue 项目升级到 webpack3</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pk4jn8.html">运行Java Web项目报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwelxv9.html">vue-cli项目在IE下运行钩子函数抛出异常&OpenCurlyDoubleQuote;ReferenceError&colon; &OpenCurlyDoubleQuote;Promise&rdquo;未定义&amp;amp&semi;quot&semi;&rdquo;的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g4lw6q.html">Cisco ASR1002-X告警处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7en1619.html">破解UltraEdit（Ver20&period;00&period;0&period;1040），无限试用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjo62vq.html">杂项：GitHub</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnngndjq.html">使用mybatis-generator生成自动代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpr1m09.html">B&period; Our Tanya is Crying Out Loud</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93zx3nq.html">p4 是否能自动merge</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zw1zn8.html">thrift之TTransport层的缓存传输类TBufferedTransport和缓冲基类TBufferBase</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rxdjd9.html">&period;NET 自带的动态代理&plus;Expression 实现AOP</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k7p079.html">dubbo配置文件报错解决思路</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyk11m9.html">C&num;课外实践&mdash;&mdash;校园二手平台（技术篇2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zwodd8.html">RequireJS源码初探</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gwj5e8.html">js随机点名</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rx5mr9.html">atitit&period;hbnt orm db 新新增更新最佳实践o99</a>
			</li>
						<li><a href="https://www.batexi.com/a/495og268.html">paip&period;提升效率--gui 的选择--swing最佳实践swt awt</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq404708.html">NGUI ScrollView 循环 Item 实现性能优化</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
